com.tibbo.aggregate.common.expression

## Class AbstractEvaluatingVisitor

- java.lang.Object
- - com.tibbo.aggregate.common.expression.AbstractEvaluatingVisitor

- All Implemented Interfaces:
    ExpressionParserVisitor
  Direct Known Subclasses:
    DefaultEvaluatingVisitor

      public abstract class AbstractEvaluatingVisitor
      extends java.lang.Object
      implements ExpressionParserVisitor

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.util.Map<java.lang.String,Function>` | `DEFAULT_FUNCTIONS`
    `protected int` | `top`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractEvaluatingVisitor(Evaluator evaluator)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static int` | `compare(java.lang.Object v1, java.lang.Object v2)`
    `void` | `describeNode(EvaluationEnvironment data, java.lang.String image)`
    `static boolean` | `equal(java.lang.Object v1, java.lang.Object v2)`
    `protected AttributedObject` | `get(int delta)`
    `protected Evaluator` | `getEvaluator()`
    `java.lang.Object` | `getResult()`
    `protected AttributedObject` | `set(int delta, AttributedObject value)`
    `AttributedObject` | `visit(ASTAddNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTBitwiseAndNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTBitwiseNotNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTBitwiseOrNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTBitwiseXorNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTConditionalNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTDivNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTEQNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTFalseNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTFloatConstNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTFunctionNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTGENode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTGTNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTLeftShiftNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTLENode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTLogicalAndNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTLogicalNotNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTLogicalOrNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTLongConstNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTLTNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTModNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTMulNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTNENode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTNullNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTRegexMatchNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTRightShiftNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTStart node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTStringConstNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTSubtractNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTTrueNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTUnaryNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(ASTUnsignedRightShiftNode node, EvaluationEnvironment data)`
    `AttributedObject` | `visit(SimpleNode node, EvaluationEnvironment data)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.tibbo.aggregate.common.expression.parser.ExpressionParserVisitor

      `visit`

- - ### Field Detail

    - #### DEFAULT_FUNCTIONS

          public static java.util.Map<java.lang.String,Function> DEFAULT_FUNCTIONS

    - #### top

          protected int top

  - ### Constructor Detail

    - #### AbstractEvaluatingVisitor

          public AbstractEvaluatingVisitor(Evaluator evaluator)

  - ### Method Detail

    - #### getEvaluator

          protected Evaluator getEvaluator()

    - #### set

          protected AttributedObject set(int delta,
                                         AttributedObject value)

    - #### getResult

          public java.lang.Object getResult()

    - #### get

          protected AttributedObject get(int delta)

    - #### describeNode

          public void describeNode(EvaluationEnvironment data,
                                   java.lang.String image)

    - #### visit

          public AttributedObject visit(SimpleNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTStart node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTConditionalNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTLogicalOrNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTLogicalAndNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTBitwiseAndNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTBitwiseOrNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTBitwiseXorNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### equal

          public static boolean equal(java.lang.Object v1,
                                      java.lang.Object v2)

    - #### compare

          public static int compare(java.lang.Object v1,
                                    java.lang.Object v2)

    - #### visit

          public AttributedObject visit(ASTEQNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTNENode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTRegexMatchNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTLTNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTGTNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTLENode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTGENode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTAddNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTSubtractNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTMulNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTDivNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTModNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTUnaryNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTLogicalNotNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTBitwiseNotNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTFunctionNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTLongConstNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTFloatConstNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTStringConstNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTTrueNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTFalseNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTNullNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTRightShiftNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTUnsignedRightShiftNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`

    - #### visit

          public AttributedObject visit(ASTLeftShiftNode node,
                                        EvaluationEnvironment data)

      Specified by:
        `visit` in interface `ExpressionParserVisitor`